<?php
############################################################################
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-USA template set)
############################################################################
#
#	Project:	Sample Included Website Design
#	Module:		Settings.php
#	Purpose:	Provides the Site Settings Used Throughout the Site
# 	Authors:	Kevin W. Reed <kreed@tnet.com>
#				TNET Services, Inc.
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
############################################################################
#	This document uses Tab 4 Settings
############################################################################
$SITE 			= array();

# Automatic Info we might need
############################################################################
$SITE['REMOTE_ADDR']	= $_SERVER['REMOTE_ADDR'];
$SITE['REMOTE_HOST']	= $_SERVER['REMOTE_HOST'];
$SITE['WEBROOT']		= $_SERVER['DOCUMENT_ROOT'];
$SITE['REQURI']			= $_SERVER['REQUEST_URI'];
$SITE['SERVERNAME']		= $_SERVER['SERVER_NAME'];

# Sitewide configuration
#
############################################################################
$SITE['charset']		= 'ISO-8859-1'; // character set for webpages (iso-8859-1=latin)
$SITE['CSSscreen']		= 'weather-screen-php.css'; // 800px design
$SITE['CSSprint']		= 'weather-print-php.css';
#
#$SITE['CSSscreen']		= 'weather-screen.css'; // Classic design
#$SITE['CSSprint']		= 'weather-print.css';

#############################################
# Mike Challis' Theme Switch configuration
$SITE['allowThemeSwitch']   = true;  // set to false to disable the the use of Theme Switcher 
$SITE['CSSscreenDefault'] = 'weather-screen-orange.css';
$SITE['CSSwideOrNarrowDefault'] = 'narrow'; // 'narrow' or 'wide'
# CSSsettings_mode
# sets allowable user style select options:
# 1 user can select style and screen width (show style select and screen width select)
# 2 user can select styles only (hide screen width select)
# 3 user can select screen width only (hide style select)
$SITE['CSSsettings_mode'] = 1;  // set to 1, 2 or 3
#############################################
$SITE['flyoutmenu'] = true; // set to false to use classic menubar.php instead

$SITE['clientrawfile']	= './clientraw.txt';  // relative FILE location of clientraw.txt

# Configurable Carterlake/WD/PHP template Site Settings
############################################################################
$SITE['WXtags']			= 'testtags.php';  // for testtags.php weather variables
$SITE['organ']			= 'USA Weather Website with WD/PHP &amp; AJAX';
$SITE['copyr']			= '&copy; ' . date("Y",time()) . ', Your Weather Website';
$SITE['remote']			= "onclick=\"window.open(this.href,'_blank');return false;\"";
$SITE['tz'] 			= 'PST8PDT';  //NOTE: this *MUST* be set correctly to
// translate UTC times to your LOCAL time for the displays.
//  http://saratoga-weather.org/timezone.txt  has the list of timezone names
//  pick the one that is closest to your location and put in $ourTZ like:
//    $ourTZ = 'America/Los_Angeles';  // or
//    $ourTZ = 'Europe/Brussels';
$SITE['location']       = 'Somewhere,Some State, USA';
$SITE['email']			= 'mailto:somebody@somemail.org';
# Weather Station sensors
$SITE['UV']				= true;  // set to false if no UV sensor
$SITE['SOLAR']			= true;  // set to false if no Solar sensor
$SITE['showSnow']		= true;   // set to false if snow not recorded on WD
$SITE['showSnowTemp'] 	= 34;	  // show snow instead of rain if temp (F) is <= this amount
# Station location: latitude, longitude, cityname
$SITE['latitude']		= '37.27153397';    //North=positive, South=negative decimal degrees
$SITE['longitude']		= '-122.02274323';  //East=positive, West=negative decimal degrees
$SITE['cityname']		= 'Saratoga';

# USA Specific settings
$SITE['noaazone'] 		= 'CAZ513'; // used for NOAA advisories and advforecast2.php forecasts
$SITE['hurlURL']		= "wxadvisory.php"; // page to launch for details on NOAA advisories
#
#Forecast script settings area
#
$SITE['UVscript']		= 'get-UV-forecast-inc.php'; // worldwide forecast script for UV Index
//	comment out above line to exclude UV forecast
//
# if you have WXSIM and plaintext-parser.php, set $SITE['WXSIM'] = true;
# to have the WXSIM forecast text appear in the dashboard along with your primary forecast org's
# forecast.  
$SITE['WXSIM']			= true;  // Set to false if no WXSIM/plaintext-parser.php
$SITE['WXSIMscript'] 	= 'plaintext-parser.php'; // script for decoding plaintext.txt into icons

# fcsturlNWS is the point-printable forecast URL from http://www.weather.gov/ (used by advforecast2.php)
$SITE['fcsturlNWS']		= 'http://forecast.weather.gov/MapClick.php?site=mtr&smap=1&textField1=37.26389&textField2=-122.02194&TextType=2';

$SITE['fcsticonsdir'] = './forecast/images/'; // NOAA-style icons for NWS, WU, WXSIM forecast scripts
#
#---- in the following section, enable settings for ONE primary forecast organization
# pick which script AND org are to be used for your forecast here: (last uncommented pair will
#  be the ones used on the wxforecast.php page and in your dashboard and sidebar
$SITE['fcstscript']		= 'advforecast2.php';  // USA-only NWS Forecast script
$SITE['fcstorg']		= 'NWS';    // set to 'NWS' for NOAA NWS

#$SITE['fcstscript']	= 'plaintext-parser.php';    // WXSIM forecast (if only forecast script)
#$SITE['fcstorg']		= 'WXSIM';    // set to 'WXSIM' for WXSIM forecast

###########################################################################

# ajax-dashboard, ajax-sidebar settings (will override defaults in
#  the scripts themselves when included in this site
###########################################################################
$SITE['WDdateMDY'] = true; // for WD date format of month/day/year.  =false for day/month/year
$SITE['uomTemp'] = '&deg;F';
$SITE['uomBaro'] = ' inHg';
$SITE['uomWind'] = ' mph';
$SITE['uomRain'] = ' in';
$SITE['uomSnow'] = ' in';
$SITE['uomDistance'] = ' miles';  // or ' km' -- used for Wind Run display
$SITE['uomPerHour'] = '/hr';
$SITE['imagesDir'] = './ajax-images/';  // directory for ajax-images with trailing slash
# note: date format used for PHP parts only.  Weather-Display dates are not processed
#   except on the astronomy page
$SITE['timeFormat'] = 'D, d-M-Y g:ia T';  // Day, 31-Mar-2006 6:35pm Tz  (USA Style)
//$SITE['timeFormat'] = 'm/d/Y g:ia';      // USA  format 03/31/2006 14:03
//$SITE['timeFormat'] = 'd/m/Y H:i';       // Euro format 31/03/2006 14:03
//$SITE['timeFormat'] = 'Y-m-d H:i';       // ISO  format 2006-03-31 14:03

$SITE['timeOnlyFormat'] = 'g:ia';          // USA format h:mm[am|pm\
#$SITE['timeOnlyFormat'] = 'H:i';          // Euro format hh:mm  (hh=00..23);
$SITE['dateOnlyFormat'] = 'd-M-Y';        // for 31-Mar-2008 or 'j/n/Y' for Euro format

# carterlake-radar settings (will override defaults in
#  the scripts themselves when included in this site
###########################################################################
$SITE['noaaradar']		= 'MUX';   			// LAST 3 characters of NOAA Radar Site ID
											// e.g. Radar KMUX has $SITE['noaaradar'] = 'MUX';
$SITE['WUregion']	= 'sw';				// Wunderground regional maps
// 'sw'=SouthWest, 'nw'=NorthWest, 'mw'=Midwest
// 'sp'=South Central, 'ne'=North East, 'se'=South East
$SITE['WUname1']	= 'City Level';		// tooltip label for mode=1
$SITE['WUname2']	= 'South SF Bay';	// tooltip label for mode=2
$SITE['WUname3']	= 'SF Bay Area';	// tooltip label for mode=3
$SITE['WUname4']	= 'Southwest US';	// tooltip label for mode=4
$SITE['WUname5']	= 'Entire US';		// tooltip label for mode=5

###########################################################################
# GRLevel3 Radar image settings
$SITE['GR3radar']	= 'kmux';	// set to lower-case full name of NEXRAD radar site
$SITE['GR3DIR']		= '/GR3'; 	// set to directory for GRLevel3 images (or '.' for root directory
$SITE['GR3type']	= 'cr';		// radar image type 'cr','br','cr248','br1' etc.
$SITE['GR3img']		= 'jpg';	// GR3 image type 'jpg' or 'png'
$SITE['GR3cnt']		= 10;		// number of images in series 10=(_0 ... _9 in name of file)
$SITE['GR3width']	= 512;		// width of GR3 images
$SITE['GR3height']  = 512;		// height of GR3 images
$SITE['showradarstatus'] = true; // set to false to suppress 'active' message

##########################################################################
# end of configurable settings
#
# set the Timezone abbreviation automatically based on $SITE['tzname'];
# Set timezone in PHP5/PHP4 manner
  if (!function_exists('date_default_timezone_set')) {
	 putenv("TZ=" . $SITE['tz']);
//	 print "<!-- using putenv(\"TZ=". $SITE['tz']. "\") -->\n";
    } else {
	 date_default_timezone_set($SITE['tz']);
//	 print "<!-- using date_default_timezone_set(\"". $SITE['tz']. "\") -->\n";
   }

$SITE['tzname']	= date("T",time());
if($SITE['allowThemeSwitch']) {
  # begin Color Theme Switcher Plugin by Mike Challis
  # http://www.642weather.com/weather/scripts.php
  include_once('include-style-switcher.php');
  $SITE['CSSscreen'] = validate_style_choice();
  # end Color Theme Switcher Plugin
}
?>