<?php
// ajax-dashboard.php  - Ken True - webmaster@saratoga-weather.org
//  Version 1.00 - 22-Dec-2007 - Initial release
//  Version 1.01 - 04-Jan-2008 - refit for WD/AJAX/PHP package
//  Version 1.02 - 18-Jan-2008 - fixed icon=34 to ra1.jpg (stopped raining)
//  Version 1.03 - 21-Feb-2008 - added icon=35 for wind/rain
//  Version 1.04 - 25-Feb-2008 - added options for UV and/or Solar display
//  Version 1.05 - 11-Mar-2008 - changed to .png for wind-rose defaults (Carterlake/AJAX/PHP templates)
//  Version 1.06 - 11-Mar-2008 - fixed fixup_time routine
//  Version 1.07 - 29-Mar-2008 - added debug features, honor $SITE['WXtags'] for testtags.php include
//  Version 1.08 - 11-Jul-2008 - added Snow feature+fixed Moonphase for WD-Mac users
//  Version 1.09 - 25-Sep-2008 - minor code fixes
//  Version 1.10 - 03-Jul-2009 - PHP5 support, merged enhancemenst from ML version
//  Version 1.11 - 10-Oct-2009 - changed snow detection logic (USA)
//
//error_reporting(E_ALL);
// --- settings for standalone use --------------------------
$uomTemp = '&deg;F';
$uomBaro = ' inHg';
$uomWind = ' mph';
$uomRain = ' in';
$uomSnow = ' in';
$uomPerHour = '/hr';
$imagesDir = './ajax-images/';  // directory for ajax-images with trailing slash
//  $timeFormat = 'D, d-M-Y g:ia T';  // Fri, 31-Mar-2006 6:35pm TZone
$timeFormat = 'd-M-Y g:ia';  // Fri, 31-Mar-2006 6:35pm TZone
$timeOnlyFormat = 'g:ia';    // h:mm[am|pm];
//$timeOnlyFormat = 'H:i';     // hh:mm
$dateOnlyFormat = 'd-M-Y';   // d-Mon-YYYY
$WDdateMDY = true;     // true=dates by WD are 'month/day/year'
//                     // false=dates by WD are 'day/month/year'

$ourTZ = "PST8PDT";  //NOTE: this *MUST* be set correctly to
// translate UTC times to your LOCAL time for the displays.
//
// optional settings for the Wind Rose graphic in ajaxwindiconwr as wrName . winddir . wrType
$wrName   = 'wr-';       // first part of the graphic filename (followed by winddir to complete it)
$wrType   = '.png';      // extension of the graphic filename
$wrHeight = '58';        // windrose graphic height=
$wrWidth  = '58';        // windrose graphic width=
$wrCalm   = 'wr-calm.png';  // set to full name of graphic for calm display ('wr-calm.gif')
$haveUV   = true;        // set to false if no UV sensor
$haveSolar = true;       // set to false if no Solar sensor
$WXtags  =  'testtags.php';  // source of our weather variables
$fcstorg =   'NWS'; // default forecast organization ('NWS','EC','WU','WXSIM')
$fcstscript = 'advforecast2.php'; // default forecast script
//            NWS - 'advforecast2.php', EC - 'ec-forecast.php', 
//            WU - 'WU-forecast.php', WXSIM - 'plaintext-parser.php',
$UVscript		= 'get-UV-forecast-inc.php'; // worldwide forecast script for UV Index
//	comment out above line to exclude UV forecast
$DavisVP	= true; 	// set to false if weather station is not a Davis VP
$showSnow	= true;		// set to false if Snow values not recorded manually in WD
$showSnowTemp = 34;		// display Snow instead of Rain when temp (F) is <= this temperature.
// --- end of settings for standalone use
//
// overrides from Settings.php if available
global $SITE;
if (isset($SITE['uomTemp'])) 	{$uomTemp = $SITE['uomTemp'];}
if (isset($SITE['uomBaro'])) 	{$uomBaro = $SITE['uomBaro'];}
if (isset($SITE['uomWind'])) 	{$uomWind = $SITE['uomWind'];}
if (isset($SITE['uomRain'])) 	{$uomRain = $SITE['uomRain'];}
if (isset($SITE['uomSnow'])) 	{$uomSnow = $SITE['uomSnow'];}
if (isset($SITE['uomPerHour'])) {$uomPerHour = $SITE['uomPerHour'];}
if (isset($SITE['imagesDir'])) 	{$imagesDir = $SITE['imagesDir'];}
if (isset($SITE['timeFormat'])) {$timeFormat = $SITE['timeFormat'];}
if (isset($SITE['timeOnlyFormat'])) {$timeOnlyFormat = $SITE['timeOnlyFormat'];}
if (isset($SITE['dateOnlyFormat'])) {$dateOnlyFormat = $SITE['dateOnlyFormat'];}
if (isset($SITE['WDdateMDY']))  {$WDdateMDY = $SITE['WDdateMDY'];}
if (isset($SITE['tz'])) 		{$ourTZ = $SITE['tz'];}
if (isset($SITE['UV'])) 		{$haveUV = $SITE['UV'];}
if (isset($SITE['SOLAR'])) 		{$haveSolar = $SITE['SOLAR'];}
if (isset($SITE['WXtags'])) 	{$WXtags = $SITE['WXtags'];}
if (isset($SITE['fcstorg']))	{$fcstorg = $SITE['fcstorg'];}
if (isset($SITE['fcstscript']))	{$fcstscript = $SITE['fcstscript'];}
if (isset($SITE['UVscript'])) 	{$UVscript = $SITE['UVscript'];}
if (isset($SITE['DavisVP'])) 	{$DavisVP = $SITE['DavisVP'];}
if (isset($SITE['showSnow'])) 	{$showSnow = $SITE['showSnow'];}
if (isset($SITE['showSnowTemp'])) 	{$showSnowTemp = $SITE['showSnowTemp'];}
if (isset($_REQUEST['sce']) && ( strtolower($_REQUEST['sce']) == 'view' or
    strtolower($_REQUEST['sce']) == 'show') ) {
   //--self downloader --
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   
   readfile($filenameReal);
   exit;
}
// testing parameters// testing parameters
$DebugMode = false;
if (isset($_REQUEST['debug'])) {$DebugMode = strtolower($_REQUEST['debug']) == 'y'; }
if (isset($_REQUEST['UV'])) {$haveUV = $_REQUEST['UV'] <> '0';}
if (isset($_REQUEST['solar'])) {$haveSolar = $_REQUEST['solar'] <> '0';}
$displaySnow = false;  // assume normal rain display
$haveSomeSnow = $snowseasoncm + $snowseasonin; // any thing in either measurment?
if ($showSnow and strip_units($temperature) <= $showSnowTemp and $haveSomeSnow > 0.0) {
  $displaySnow = true;
}
if (isset($_REQUEST['snow'])) {$displaySnow = $_REQUEST['snow'] <> '0';}

$fcstby = isset($_REQUEST['fcstby'])?strtoupper($_REQUEST['fcstby']):'';
if ($fcstby == 'NWS') {
$SITE['fcstscript']		= 'advforecast2.php';  // USA-only NWS Forecast script
$SITE['fcstorg']		= 'NWS';    // set to 'NWS' for NOAA NWS
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}

if ($fcstby == 'EC') {

$SITE['fcstscript']   = 'ec-forecast.php';    // Canada forecasts from Environment Canada
$SITE['fcstorg']		= 'EC';    // set to 'EC' for Environment Canada
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'WU') {

$SITE['fcstscript']	= 'WU-forecast.php';    // Non-USA, Non-Canada Wunderground Forecast Script
$SITE['fcstorg']		= 'WU';    // set to 'WU' for WeatherUnderground
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
if ($fcstby == 'WXSIM') {

$SITE['fcstscript']	= 'plaintext-parser.php';    // WXSIM forecast
$SITE['fcstorg']		= 'WXSIM';    // set to 'WXSIM' for WXSIM forecast
$fcstorg = $fcstby;
$fcstscript = $SITE['fcstscript'];
}
// end of special testing parms
print "<!-- fcstby='$fcstby' fcstscript='" . $SITE['fcstscript'] . "' fcstorg='". $SITE['fcstorg'] . "' -->\n"; 
// end of overrides from Settings.php

  include_once($WXtags);   // for the bulk of our data
  $doPrintNWS = false; // suppress printing of forecast by advforecast2.php
  $doPrint    = false; // suppress printing of ec-forecast.php
  $doPrintWU  = false; // suppress printing of WU-forecast.php
  include_once($fcstscript); // for the forecast icon stuff
  
// copy forecast script variables to carterlake-style names if script used is not advforecast2.php
if ($fcstorg == 'WU') {
  $forecasticons = $WUforecasticons;
  $forecasttemp = $WUforecasttemp;
  $forecasttitles = $WUforecasttitles;
  $forecasttext = $WUforecasttext;

} else if ($fcstorg == 'EC') {
  foreach ($forecasticon as $i => $temp) {
  	$forecasticons[$i] = $forecasttitles[$i] . "<br />\n" .
	               $forecasticon[$i] . "\n" .
				   $forecasttext[$i] . "\n";
  }
  $forecasttext = $forecastdetail;
  foreach ($forecastdays as $i => $temp) {
     $t = explode('<br />',$forecastdays[$i]);
     $forecasttitles[$i] = $t[0];
  }

} else if ($fcstorg == 'WXSIM') {

  $forecasticons = $WXSIMicons;
  $forecasttemp  = $WXSIMtemp;
  $forecasttitles = $WXSIMday;
  $forecasttext = $WXSIMtext;

}
if (isset($SITE['WXSIM']) and $SITE['WXSIM'] == true and $fcstorg <> 'WXSIM') {
  $doPrint = false;
  include_once($SITE['WXSIMscript']);
}


// --- end of settings -------------------

// Sample from WD: $moonage = "Moon age: 10 days,10 hours,41 minutes,80%";	// current age of the moon (days since new moon)
// Sample from WD: $moonphase = "80%";	// Moon phase %
  $moonagedays = preg_replace('|^Moon age:\s+(\d+)\s.*$|is',"\$1",$moonage);
  if($moonphase == '') { // MAC version of WD is missing this value
    preg_match_all('|(\d+)|is',$moonage,$matches);
    $moonphase  = $matches[1][3];
	if(isset($matches[1][4])) {
	  $moonphase .= '.' . $matches[1][4]; // pick up decimal;
	  $moonphase = round($moonphase,0);
	}
	$moonphase .= '%';
  }
# Set timezone in PHP5/PHP4 manner
  if (!function_exists('date_default_timezone_set')) {
	putenv("TZ=" . $ourTZ);
#	$Status .= "<!-- using putenv(\"TZ=$ourTZ\") -->\n";
    } else {
	date_default_timezone_set("$ourTZ");
#	$Status .= "<!-- using date_default_timezone_set(\"$ourTZ\") -->\n";
   }
  $UpdateDate = date($timeFormat,strtotime("$date_year-$date_month-$date_day  $time_hour:$time_minute:00"));
//  $UpdateDate = "$date_year-$date_month-$date_day  $time_hour:$time_minute:00";
//
// Snow setup
if (preg_match('|in|i',$uomSnow)) { // use USA measurements
  $snowseason = $snowseasonin;	// Snow for season you have entered under input daily weather, inches
  $snowmonth = $snowmonthin;	// Snow for month you have entered under input daily weather, inches
  $snowtoday = $snowtodayin;	// Snow for today you have entered under input daily weather, inches
  $snowyesterday = $snowyesterday;	// Yesterdays' snow
  $snownow = $snownowin;	// Current snow depth, inches.
} else { // use Metric measurements
  $snowseason = $snowseasoncm;	// Snow for season you have entered under input daily weather, cm
  $snowmonth = $snowmonthcm;	// Snow for month you have entered under input daily weather, cm
  $snowtoday = $snowtodaycm;	// Snow for today you have entered under input daily weather, cm
  $snowyesterday = $snowyesterday;	// Yesterdays' snow
  $snownow = $snownowcm;	// Current snow depth, cm.
}
if($snowtoday == '---' or $snowtoday == '') {$snowtoday = '0';}
// --- end of initialization code ---------
print "<!--  ajax-dashboard.php - 1.11 - 10-Oct-2009 USA version-->\n";
?>
<!-- start of ajax-dashboard.php -->
<div class="ajaxDashboard">
      <table width="620" border="0" cellpadding="2" cellspacing="1" style="border:solid; border-color: #CCCCCC;">
        <tr align="center">
          <td class="data1" colspan="4" style="text-align: center">
		    <span class="ajax" id="ajaxindicator">Updated:</span>&nbsp;@ 
		    <span class="ajax" id="ajaxdate">
		    <?php echo fixup_date($date) . ' ' . fixup_time($time) . " - next update at " . fixup_time($timeofnextupdate); ?>
		    </span>&nbsp;<span class="ajax" id="ajaxtime"></span>
            <script type="text/javascript">
<!--
document.write('<b> - updated <span id="ajaxcounter"></span>&nbsp;sec ago</b>');
//-->
            </script>
          </td>
        </tr>
        <tr align="center">
          <td class="datahead">Summary / Temperature</td>
          <td class="datahead">Wind</td>
	  <?php if($displaySnow) { ?>
          <td class="datahead">Snow</td>
	  <?php } else { ?>
          <td class="datahead">Rain
		  <?php if($snownow > 0) { echo ' / Snow Depth'; }?></td>
	  <?php } // end displaySnow ?>
          <td class="datahead">Outlook</td>
        </tr>
        <tr align="left">
          <td valign="top" rowspan="5">
		    <table width="180" border="0" cellpadding="2" cellspacing="0">
			  <tr>
				<td align="center" valign="top" class="data1" style="text-align: center;border: none">
				<span class="ajax" id="ajaxconditionicon2">
				  <img src="<?php echo $imagesDir . newIcon($iconnumber) ?>"  
					alt="<?php $t1 = fixupCondition($Currentsolardescription);
						  echo $t1; ?>" 
					title="<?php echo $t1; ?>" height="58" width="55" />
				</span> 
				</td>
				<td class="data1" style="text-align: center;border: none"><span class="ajax" id="ajaxcurrentcond">
				  <?php echo $t1; ?> </span> 
				</td>
			  </tr>
              <tr align="center">
                <td align="center" valign="top" class="data1" style="text-align: center;border: none">
				  <span class="ajax" id="ajaxthermometer">
                  <?php $tstr = "Currently $temperature, Max: $maxtemp, Min: $mintemp"; ?>
                  <img src="thermometer.php?t=<?php echo strip_units($temperature); ?>" alt="<?php echo $tstr; ?>"
		           title="<?php echo $tstr; ?>" height="170" width="54" /> </span> 
				</td>
                <td class="data1" style="text-align: center;border: none" valign="middle">
				  <span class="ajax" id="ajaxtemp" style="font-size:20px">
				    <?php echo strip_units($temperature) . $uomTemp; ?> 
				  </span>
				  <br/>
				  <span class="ajax" id="ajaxtemparrow"><?php echo gen_difference(
				     $temperature, strip_units($temperature) -strip_units($tempchangehour), '',
			         'Warmer %s'.$uomTemp.' than last hour.',
			         'Colder %s'.$uomTemp.' than last hour.');?></span>
				  <br/><br/>
                    <span class="ajax" id="ajaxheatcolorword"><?php  echo $heatcolourword; ?></span>
                  <br/><br/>
                  Feels like: <span class="ajax" id="ajaxfeelslike">
				    <?php echo $feelslike . $uomTemp; ?> 
					</span>
				  <br/><br/>
                  24-hr difference
				  <br />
                  <?php 
					echo gen_difference($temperature, $temp24hoursago, $uomTemp,
					'Warmer %s'.$uomTemp.' than yesterday at this time.',
					'Colder %s'.$uomTemp.' than yesterday at this time.'); ?>
                </td>
              </tr>
              <tr>
                <td colspan="2">
				  <table width="100%"  class="data1" style="font-size: 9px;border: none">
                    <tr>
                      <th>&nbsp;</th>
                      <th style="text-align: center;">Today</th>
                      <th style="text-align: center;">Yesterday</th>
                    </tr>
                    <tr>
                      <td><strong>High:</strong></td>
                      <td style="text-align: center;">
					    <span class="ajax" id="ajaxtempmax">
                        <?php echo strip_units($maxtemp) . $uomTemp; ?>
                        </span><br />
                        <?php echo fixup_time($maxtempt); ?>
					  </td>
                      <td style="text-align: center;"><?php 
			            echo strip_units($maxtempyest) . $uomTemp; ?>
                        <br />
                        <?php echo fixup_time($maxtempyestt); ?>
					  </td>
                    </tr>
                    <tr>
                      <td><strong>Low:</strong></td>
                      <td style="text-align: center;">
					    <span class="ajax" id="ajaxtempmin">
                        <?php 
			               echo strip_units($mintemp) . $uomTemp; ?>
                        </span><br />
                        <?php echo fixup_time($mintempt); ?>
					  </td>
                      <td style="text-align: center;"><?php 
			               echo strip_units($mintempyest) . $uomTemp; ?>
                        <br />
                        <?php echo fixup_time($mintempyestt); ?>
					  </td>
                    </tr>
                  </table>
				</td>
              </tr>
            </table>
		  </td>
          <td valign="middle">
		    <table width="180" border="0" cellpadding="2" cellspacing="0">
              <tr>
                <td class="data1" valign="middle" align="center" style="border: none">
				  <img src="<?php echo $imagesDir; ?>spacer.gif" width="1" 
				    height="<?php echo $wrHeight; ?>" alt=" " align="left"/>
				  <span class="ajax" id="ajaxwindiconwr">
				  <?php $wr = $imagesDir . $wrName . $dirlabel . $wrType; // normal wind rose
				        $wrtext = "Wind from $dirlabel";
						if ( (strip_units($avgspd) + strip_units($gstspd) < 0.1 ) and
						     ($wrCalm <> '') ) { // use calm instead
						  $wr = $imagesDir . $wrCalm;
						  $wrtext = $bftspeedtext;
						 }
						
				  ?>
				    <img src="<?php echo $wr; ?>" 
					height="<?php echo $wrHeight; ?>" width="<?php echo $wrWidth; ?>" 
					title="<?php echo $wrtext; ?>" 
					alt="<?php echo $wrtext; ?>"  style="text-align:center" />
				   </span> 
				 </td>
                <td valign="middle" class="data1" style="text-align: center; border: none;" >
					<span class="ajax" id="ajaxwinddir"> <?php echo $dirlabel; ?></span><br/> 
					<span class="ajax" id="ajaxwind">
					 <?php echo strip_units($avgspd); ?>
					</span><br/>
					<span class="meas">Gust:<br/></span> 
					<span class="ajax" id="ajaxgust">
					  <?php echo $gstspd; ?>
					</span> 
				</td>
              </tr>
               <tr>
                <td colspan="2" class="data1" align="center" style="text-align:center">
				  <span class="ajax" id="ajaxbeaufortnum"><?php echo strip_units($beaufortnum); ?></span> Bft - <i>
				  <span class="ajax" id="ajaxbeaufort"><?php echo $bftspeedtext; ?></span></i>
				</td>
              </tr>
             <tr>
                <td colspan="2" class="data1" align="center">
				  Today: 
				  <span class="ajax" id="ajaxwindmaxgust"><?php echo strip_units($maxgst); ?></span> 
				  <span class="ajax" id="ajaxwindmaxgusttime"><?php echo fixup_time($maxgstt); ?></span>
				</td>
              </tr>
              <tr>
                <td colspan="2" class="data1" align="center">
				  Gust Month: <?php echo $mrecordwindgust; ?> 
				  <?php echo substr($monthname,0,3) . " " . $mrecordhighgustday; ?> 
				</td>
              </tr>
            </table>
		  </td>
          <td valign="middle"><table width="166" border="0" cellpadding="2" cellspacing="0">
    <?php if ($displaySnow) { // display Snow instead of Rain ?>
              <tr>
                <td class="data1">Snow Today:</td>
                <td style="text-align: right;" class="data1">
                    <?php echo strip_units($snowtoday) . $uomSnow; ?>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap">Snow Yesterday: </td>
                <td style="text-align: right;" class="data1">
                  <?php echo strip_units($snowyesterday) . $uomSnow; ?>
				</td>
              </tr>
             <tr>
                <td class="data1">This Month:</td>
                <td style="text-align: right;" class="data1">
                  <?php echo strip_units($snowmonth) . $uomSnow; ?>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap">Winter Total:</td>
                <td style="text-align: right;" class="data1">
                    <?php echo strip_units($snowseason) . $uomSnow; ?>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap">Snow Depth:</td>
                <td style="text-align: right;" class="data1">
                    <?php echo strip_units($snownow) . $uomSnow; ?>
				</td>
              </tr>
              <tr>
                <td class="data1" colspan="2">
				<?php 
				   print "$snowdaysthismonth " ;
				   print ($snowdaysthismonth <> 1)?'snow days in':'snow day in';
				   print " " . substr($monthname,0,3) . ".";
				 ?>
                </td>
              </tr>
	<?php } else { // display Rain ?>
              <tr>
                <td class="data1">Rain Today:</td>
                <td style="text-align: right;" class="data1">
				  <span class="ajax" id="ajaxrain">
                    <?php echo strip_units($dayrn) . $uomRain; ?>
                  </span>
				</td>
              </tr>
              <tr>
                <td class="data1">Rain Rate (<?php echo $uomPerHour; ?>):</td>
                <td style="text-align: right;" class="data1">
				  <span class="ajax" id="ajaxrainratehr">
                  <?php echo strip_units($currentrainratehr) . $uomRain; ?>
                  </span>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap">Rain Yesterday: </td>
                <td style="text-align: right;" class="data1">
				  <span class="ajax" id="ajaxrainydy">
                  <?php echo strip_units($yesterdayrain) . $uomRain; ?>
                  </span>
				</td>
              </tr>
			  <?php if ($DavisVP) { // Storm Rain is a Davis VP thing ?>
               <tr>
                <td class="data1" nowrap="nowrap">Storm Rain: </td>
                <td style="text-align: right;" class="data1">
                  <?php echo strip_units($vpstormrain).$uomRain; ?>
				</td>
              </tr>
			  <?php } // end of DavisVP specific variable ?>
             <tr>
                <td class="data1">This Month:</td>
                <td style="text-align: right;" class="data1">
				  <span class="ajax" id="ajaxrainmo">
                  <?php echo strip_units($monthrn) . $uomRain; ?>
                  </span>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap">Season Total:</td>
                <td style="text-align: right;" class="data1">
				  <span class="ajax" id="ajaxrainyr">
                    <?php echo strip_units($yearrn) . $uomRain; ?>
                  </span>
				</td>
              </tr>
			  <?php if($snownow > 0) { // show depth of snow if needed ?>
              <tr>
                <td class="data1" nowrap="nowrap">Snow Depth:</td>
                <td style="text-align: right;" class="data1">
                    <?php echo strip_units($snownow) . $uomSnow; ?>
				</td>
              </tr>
			  <?php } // end show-depth-of-snow if needed ?>
              <tr>
                <td class="data1" colspan="2">
				  <?php 
					 if ($dayswithrain <= 0 and strip_units($dayrn) <= 0) {
					   print "$dayswithnorain "; 
					   print ($dayswithnorain > 1)?'days since last rain':'day since last rain';
					   print  "."; 
					  } else { 
					   print "$dayswithrain " ;
					   print ($dayswithrain > 1)?'rain days in':'rain day in';
					   print " " . substr($monthname,0,3) . ".";
					  } ?>
                </td>
              </tr>
	 <?php } // end snow or rain display ?>
            </table>
		  </td>
          <td align="center" valign="middle">
		    <table border="0" cellpadding="2" cellspacing="0">
              <tr>
                <td class="data1" align="center" style="font-size: 8pt; border:none;text-align: center">
				  <?php print $forecasticons[1]; ?>
			   </td>
              </tr>
            </table>
		  </td>
        </tr>
        <tr align="center" valign="top">
          <td class="datahead">Humidity &amp; Barometer</td>
          <td class="datahead">Almanac</td>
          <td class="datahead">Moon</td>
        </tr>
        <tr align="center" valign="middle">
          <td valign="middle"><table width="180" border="0" cellpadding="2" cellspacing="0">
              <tr>
                <td class="data1">Humidity:</td>
                <td style="text-align: center;" class="data1">
				  <span class="ajax" id="ajaxhumidity">
                    <?php echo $humidity; ?>
                  </span>%
                  <?php
					 $t1 = preg_replace('|\s|s','',$humchangelasthour); 
					 echo gen_difference($humidity, $humidity-$t1, '',
					 'Increased %s%% since last hour.',
					 'Decreased %s%% since last hour.');?>
				</td>
              </tr>
              <tr>
                <td class="data1">Dew Point: </td>
                <td style="text-align: center;" class="data1">
				  <span class="ajax" id="ajaxdew">
                  <?php $t1 = strip_units($dewpt); echo $t1 . $uomTemp;  ?>
                  </span>
                  <?php
					 echo gen_difference(
					 $dewpt, $t1-$dewchangelasthour, '',
					 'Increased %s'.$uomTemp.' since last hour.',
					 'Decreased %s'.$uomTemp.' since last hour.'); ?>
                </td>
              </tr>
              <tr>
                <td class="data1">Barometer:</td>
                <td style="text-align: center;" class="data1">
				  <span class="ajax" id="ajaxbaro">
                    <?php $t1 = strip_units($baro); echo $t1 . $uomBaro; ?>
                  </span>
				  <span class="ajax" id="ajaxbaroarrow">
                  <?php
					 echo gen_difference($t1, $t1-strip_units($trend), '',
					 'Rising %s '.$uomBaro.$uomPerHour,
					 'Falling %s '.$uomBaro.$uomPerHour); 
				   ?>
                   </span>
				 </td>
              </tr>
              <tr>
                <td class="data1">Baro Trend: </td>
                <td style="text-align: center;" class="data1">
				  <span class="ajax" id="ajaxbarotrendtext">
                  <?php  echo $pressuretrendname; ?>
                  </span>
				</td>
              </tr>
            </table>
		  </td>
          <td align="center" valign="middle">
		    <table width="166" border="0" cellpadding="2" cellspacing="0">
              <tr>
                <td class="data1">Sunrise:</td>
                <td style="text-align: right;" class="data1">
				  <?php echo fixup_time($sunrise); ?>
			    </td>
              </tr>
              <tr>
                <td class="data1">Sunset:</td>
                <td style="text-align: right;" class="data1">
				  <?php echo fixup_time($sunset); ?>
				</td>
              </tr>
              <tr>
                <td class="data1">Moonrise:</td>
                <td style="text-align: right;" class="data1">
				  <?php echo fixup_time($moonrise); ?>
				</td>
              </tr>
              <tr>
                <td class="data1">Moonset:</td>
                <td style="text-align: right;" class="data1">
				  <?php echo fixup_time($moonset); ?>
				</td>
              </tr>
            </table>
		  </td>
          <td rowspan="3" valign="middle" align="center">
		    <table border="0" cellpadding="4" cellspacing="0">
              <tr>
                <td class="data1" style="text-align: center; border: none;">
				  <?php echo moonphase($moonage); ?>
				</td>
              </tr>
              <tr>
                <td style="text-align: center;"><img src="<?php 
				  echo $imagesDir . '/moon' . $moonagedays; ?>.gif" 
				  alt="<?php $t1 =  moonphase($moonage) . ", Moon at $moonagedays days in cycle";
				  echo $t1; ?>" 
				  title="<?php echo $t1; ?>" 
				  width="48" height="48" style="border: 0;" />
			    </td>
              </tr>
              <tr>
                <td class="data1" style="text-align: center; border: none;" >
				  <?php  echo $moonphase; ?>
                    <br />
                  Illuminated
				</td>
              </tr>
            </table>
		  </td>
        </tr>
<?php 
// construct 4 flavors of the UV/ Solar display based on status of $haveUV and $haveSolar
// $haveUV && $haveSolar :  UV on left, Solar on Right
// $haveUV && !$haveSolar:  UV on left, UV Forecast on right
// !$haveUV && $haveSolar:  UV forecast on left, Solar on right
// !$haveUV && !$haveSolar: UV Forecast on left, UV Forecast+1 on right

$leftHead = 'UV Index';
if (!$haveUV) { $leftHead = 'UV Index Forecast'; }

$rightHead = 'Solar Radiation';
if (!$haveSolar) {$rightHead = 'UV Index Forecast'; }

if (isset($UVscript) and ! isset($UVfcstDate[0])) { // load up the UV forecast script
$UVfcstDate = array_fill(0,9,'');   // initialize the return arrays
$UVfcstUVI  = array_fill(0,9,'n/a');

  @include_once($UVscript);
}
$UVptr = 0;  // index for which day to use
?>
        <tr>
          <td class="datahead" style="text-align:center"><?php echo $leftHead; ?></td>
          <td class="datahead" style="text-align:center"><?php echo $rightHead; ?></td>
        </tr>
        <tr>
          <td align="center">
		    <table width="180" border="0" cellpadding="2" cellspacing="0">
<?php
  if ($haveUV) {  //  Have a UV sensor .. show realtime data
?>
              <tr>
                <td class="data1" nowrap="nowrap" style="text-align: center; ">&nbsp;&nbsp;
				  <span class="ajax" id="ajaxuv">
				    <?php echo $VPuv; ?>
				  </span>&nbsp;&nbsp;
				  <span class="ajax" id="ajaxuvword">
				    <?php echo get_UVrange($VPuv); ?>
				  </span>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt;">
				  High: <?php echo $highuv; ?> @&nbsp;<?php echo fixup_time($highuvtime); ?> 
				</td>
              </tr>
<?php } else {  //  don't have UV sensor .. show UV forecast instead ?>
              <tr>
                <td class="data1" nowrap="nowrap" style="text-align: center; ">
				    <?php echo $UVfcstDate[$UVptr]; ?>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt;">
				    <b><a href="<?php echo htmlspecialchars($UV_URL); ?>" title="<?php echo strip_tags($requiredNote); ?>"><?php echo $UVfcstUVI[$UVptr]; ?></a></b>
				  &nbsp;&nbsp;
				    <?php echo get_UVrange($UVfcstUVI[$UVptr]); ?>
				</td>
              </tr>
			  <?php $UVptr++; // increment counter in case they have no solar either ?>
<?php } // end $haveUV  ---------------------------------------- ?>
            </table>
		  </td>
          <td align="center">
		    <table width="166" border="0" cellpadding="2" cellspacing="0">
<?php if ($haveSolar) {  // Have a Solar Sensor  show current values ?>
              <tr>
                <td class="data1" style="text-align: center;" nowrap="nowrap" >
				  <span class="ajax" id="ajaxsolar">
				    <?php echo $VPsolar; ?></span> W/m<sup>2</sup> 
					 (<span class="ajax" id="ajaxsolarpct"><?php echo strip_units($currentsolarpercent); ?>
                     </span>%)
				</td>
              </tr>
              <tr>
                <td style="text-align: center; font-size: 8pt;" class="data1">
				  High:
                  <?php echo $highsolar; ?>
                  @&nbsp;
                  <?php echo fixup_time($highsolartime); ?>
				</td>
              </tr>
<?php } else { // don't have solar  show UV forecast instead ?>
              <tr>
                <td class="data1" nowrap="nowrap" style="text-align: center; ">
				    <?php echo $UVfcstDate[$UVptr]; ?>
				</td>
              </tr>
              <tr>
                <td class="data1" nowrap="nowrap" style="text-align:center; font-size: 8pt;">
				    <b><a href="<?php echo htmlspecialchars($UV_URL); ?>" title="<?php echo strip_tags($requiredNote); ?>"><?php echo $UVfcstUVI[$UVptr]; ?></a></b>
				  &nbsp;&nbsp;
				    <?php echo get_UVrange($UVfcstUVI[$UVptr]); ?>
				</td>
              </tr>
<?php } // end $haveSolar  ?>
            </table>
		  </td>
        </tr>
      </table>

<table width="620" border="0" cellpadding="3" cellspacing="3">
   <tr>
     <td style="text-align: left" class="datahead">&nbsp;<?php print $fcstorg; ?> Weather Forecast&nbsp; - &nbsp;<?php echo $forecasttitles[0]; ?>'s and <?php echo $forecasttitles[1]; ?>'s Outlook</td>
     </tr>
     <tr>
       <td align="center">
	    <table width="620" border="0" cellpadding="3" cellspacing="3">
           <tr>
		   <td class="data1" style="width: 80px;font-size: 8pt;border: none;text-align: center" valign="middle" align="center"><strong><?php echo $forecasticons[0] . "</strong><br />" . $forecasttemp[0]; ?></td>
           <td style="width: 504px;" class="data1"><?php print "<b>$fcstorg forecast:</b> " . $forecasttext[0] . "<br />\n";
		   if ($fcstorg <> 'WXSIM' and isset($WXSIMtext[0]) ) {
		      print '              <b>WXSIM forecast:</b> ' . $WXSIMtext[0] . "<br/>\n";
		   }
		   if ($vpforecasttext <> '') {
		      print '		   	   <b>Davis VP+ forecast:</b> <span style="color: green; font-size:9pt">' . ucfirst($vpforecasttext) . "</span>"; 
			} ?></td>
           </tr>
		   <tr><td colspan="2">&nbsp;</td></tr>
           <tr>
		   <td class="data1" style="width: 80px;font-size: 8pt; border:none; text-align: center" valign="middle" align="center"><strong><?php echo $forecasticons[1] . "</strong><br />" . $forecasttemp[1]; ?></td>
           <td style="width: 504px;" class="data1"><?php print "<b>$fcstorg forecast:</b> " . $forecasttext[1];
		   if ($fcstorg <> 'WXSIM' and isset($WXSIMtext[1]) ) {
		      print '              <br/><b>WXSIM forecast:</b> ' . $WXSIMtext[1] . "\n";
		   }
		    ?>			</td>
           </tr>
       </table>
	 </td>
   </tr>
 </table>
 </div>
 <!-- end of ajax-dashboard.php -->

<?php

//=========================================================================
//
// Functions
//
//=========================================================================
//  generate an up/down arrow to show differences

function gen_difference( $nowTemp, $yesterTemp, $Legend, $textUP, $textDN) {
  global $imagesDir;
  $diff = round(strip_units($nowTemp) - strip_units($yesterTemp),3);
  $absDiff = abs($diff);
  $diffStr = sprintf("%01.0f",$diff);
  $absDiffStr = sprintf("%01.0f",$absDiff);
  if ($diff == 0) {
 // no change

$image = '&nbsp;'; 
  
  } elseif ($diff > 0) {
// today is greater 
$msg = sprintf($textUP,$absDiff); 
$image = "<img src=\"${imagesDir}rising.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";

  
  } else {
// today is lesser
$msg = sprintf($textDN,$absDiff); 
$image = "<img src=\"${imagesDir}falling.gif\" alt=\"$msg\" title=\"$msg\" width=\"7\" height=\"8\" style=\"border: 0; margin: 1px 3px;\" />";
   
  }
   if ($Legend) {
       return ($diff . $Legend . $image);
	} else {
	   return $image;
	}
}

//=========================================================================
//  decode UV to word+color for display

function get_UVrange ( $uv ) {
// figure out a text value and color for UV exposure text
//  0 to 2  Low
//  3 to 5 	Moderate
//  6 to 7 	High
//  8 to 10 Very High
//  11+ 	Extreme
   switch (TRUE) {
     case ($uv == 0):
       $uv = 'None';
     break;
     case (($uv > 0) and ($uv < 3)):
       $uv = '<span style="border: solid 1px; color: black; background-color: #A4CE6a;">&nbsp;Low&nbsp;</span>';
     break;
     case (($uv >= 3) and ($uv < 6)):
       $uv = '<span style="border: solid 1px; color: black; background-color: #FBEE09;">&nbsp;Medium&nbsp;</span>';
     break;
     case (($uv >=6 ) and ($uv < 8)):
       $uv = '<span style="border: solid 1px; color: black; background-color: #FD9125;">&nbsp;High&nbsp;</span>';
     break;
     case (($uv >=8 ) and ($uv < 11)):
       $uv = '<span style="border: solid 1px; color: #FFFFFF; background-color: #F63F37;">&nbsp;Very&nbsp;High&nbsp;</span>';
     break;
     case (($uv >= 11) ):
       $uv = '<span style="border: solid 1px; color: #FFFF00; background-color: #807780;">&nbsp;Extreme&nbsp;</span>';
     break;
   } // end switch
   return $uv;
} // end get_UVrange

//=========================================================================
// change the hh:mm AM/PM to h:mmam/pm format
function fixup_time ( $WDtime ) {
  global $timeOnlyFormat,$DebugMode;
  if ($WDtime == "00:00: AM") { return ''; }
  $t = split(':',$WDtime);
  if (preg_match('/pm/i',$WDtime)) { $t[0] = $t[0] + 12; }
  if ($t[0] > 23) {$t[0] = 12; }
  if (preg_match('/^12.*am/i',$WDtime)) { $t[0] = 0; }
  $t2 = join(':',$t); // put time back to gether;
  $t2 = preg_replace('/[^\d\:]/is','',$t2); // strip out the am/pm if any
  $r = date($timeOnlyFormat , strtotime($t2));
  if ($DebugMode) {
    $r = "<!-- fixup_time WDtime='$WDtime' t2='$t2' -->" . $r;
    $r = '<span style="color: green;">' . $r . '</span>'; 
  }
  return ($r);
}

//=========================================================================
// adjust WD date to desired format
//
function fixup_date ($WDdate) {
  global $timeFormat,$timeOnlyFormat,$dateOnlyFormat,$WDdateMDY,$DebugMode;
  $d = split('/',$WDdate);
  if ($d[2] > 70 and $d[2] <= 99) {$d[2] += 1900;} // 2 digit dates 70-99 are 1970-1999
  if ($d[2] < 99) {$d[2] += 2000; } // 2 digit dates (left) are assumed 20xx dates.
  if ($WDdateMDY) {
    $new = sprintf('%04d-%02d-%02d',$d[2],$d[0],$d[1]); //  M/D/YYYY -> YYYY-MM-DD
  } else {
    $new = sprintf('%04d-%02d-%02d',$d[2],$d[1],$d[0]); // D/M/YYYY -> YYYY-MM-DD
  }
  
  $r = date($dateOnlyFormat,strtotime($new));
  if ($DebugMode) {
    $r = "<!-- fixup_date WDdate='$WDdate', WDdateUSA='$WDdateMDY' new='$new' -->" . $r;
    $r = '<span style="color: green;">' . $r . '</span>'; 
  }
  return ($r);
}

//=========================================================================
// strip trailing units from a measurement
// i.e. '30.01 in. Hg' becomes '30.01'
function strip_units ($data) {
  preg_match('/([\d\.\+\-]+)/',$data,$t);
  return $t[1];
}

//=========================================================================
// decode WD %moonage% tag and return a text description for the moon phase name
// "Moon age: 10 days,10 hours,41 minutes,80%"

function moonphase ($WDmoonage) {

  preg_match_all('|(\d+)|is',$WDmoonage,$matches);
//  print "<!-- matches=\n" . print_r($matches,true) . "-->\n";
  $mdays = $matches[1][0];
  $mhours = $matches[1][1];
  $mmins = $matches[1][2];
  $mpct  = $matches[1][3];
  
  $mdaysd = $mdays + ($mhours / 24) + ($mmins / 1440);
  // Definitions from http://www.answers.com/topic/lunar-phase
  //  * Dark Moon - Not visible
  //  * New Moon - Not visible, or traditionally, the first visible crescent of the Moon
  //  * Waxing Crescent Moon - Right 1-49% visible
  //  * First Quarter Moon - Right 50% visible
  //  * Waxing gibbous Moon - Right 51-99% visible
  //  * Full Moon - Fully visible
  //  * Waning gibbous Moon - Left 51-99% visible
  //  * Third Quarter Moon - Left 50% visible
  //  * Waning Crescent Moon - Left 1-49% visible
  //  * New Moon - Not visible

  if ($mdaysd <= 29.53/2) { // increasing illumination
    $ph = "Waxing";
	$qtr = "First";
  } else { // decreasing illumination
    $ph = "Waning";
	$qtr = "Last";
  }
  
  if ($mpct < 1 ) { return("New Moon"); }
  if ($mpct <= 49) { return("$ph Crescent"); }
  if ($mpct < 51) { return("$qtr Quarter"); }
  if ($mpct < 99) { return("$ph Gibbous"); }
	return("Full Moon");
 }


//=========================================================================
// pick the NOAA style condition icon based on iconnumber 
function newIcon($numb) {

  $iconList = array(
	"skc.jpg",          //  0 imagesunny.visible
	"nskc.jpg",         //  1 imageclearnight.visible
	"bkn.jpg",          //  2 imagecloudy.visible
	"sct.jpg",          //  3 imagecloudy2.visible
	"nbkn.jpg",         //  4 imagecloudynight.visible
	"sct.jpg",          //  5 imagedry.visible
	"fg.jpg",           //  6 imagefog.visible
	"hazy.jpg",         //  7 imagehaze.visible
	"ra.jpg",           //  8 imageheavyrain.visible
	"few.jpg",          //  9 imagemainlyfine.visible
	"mist.jpg",         // 10 imagemist.visible
	"nfg.jpg",          // 11 imagenightfog.visible
	"nra.jpg",          // 12 imagenightheavyrain.visible
	"novc.jpg",         // 13 imagenightovercast.visible
	"nra.jpg",          // 14 imagenightrain.visible
	"nshra.jpg",        // 15 imagenightshowers.visible
	"nsn.jpg",          // 16 imagenightsnow.visible
	"ntsra.jpg",        // 17 imagenightthunder.visible
	"ovc.jpg",          // 18 imageovercast.visible
	"sct.jpg",          // 19 imagepartlycloudy.visible
	"ra.jpg",           // 20 imagerain.visible
	"ra.jpg",           // 21 imagerain2.visible
	"shra.jpg",         // 22 imageshowers2.visible
	"ip.jpg",           // 23 imagesleet.visible
	"ip.jpg",           // 24 imagesleetshowers.visible
	"sn.jpg",           // 25 imagesnow.visible
	"sn.jpg",           // 26 imagesnowmelt.visible
	"sn.jpg",           // 27 imagesnowshowers2.visible
	"skc.jpg",          // 28 imagesunny.visible
	"scttsra.jpg",      // 29 imagethundershowers.visible
	"hi_tsra.jpg",      // 30 imagethundershowers2.visible
	"tsra.jpg",         // 31 imagethunderstorms.visible
	"nsvrtsra.jpg",     // 32 imagetornado.visible
	"wind.jpg",         // 33 imagewindy.visible
	"ra1.jpg",          // 34 stopped rainning
	"windyrain.jpg"     // 35 windy/rain 
	);	
	
	return($iconList[$numb]);
}				
// Function to process %Currentsolarcondition% string and 
// remove duplicate stuff, then fix capitalization, and translate from English if needed
//  
  function fixupCondition( $inCond ) {
    $Cond = str_replace('_',' ',trim($inCond));
	$Cond = strtolower($Cond);
	$vals = explode("/",$Cond);
	$ocnt = count($vals);
	foreach ($vals as $k => $v) { 
	  $v = ucfirst(strtolower(trim($v)));
	  $vals[$k] = $v; 
	}
	if($vals[0] == '') {$junk = array_shift($vals);}
	if(isset($vals[2]) and $vals[0] == $vals[2]) {$junk = array_pop($vals);}
	reset($vals);
	$t = join(', ',$vals);
//	return($Cond . "' orig=$ocnt n=" . count($vals) ." t='$t'");
    return($t);
  }
// end of functions
//=========================================================================
?>