<?php
//This script modifies Tom Chaplin's advisory script to use/share Ken True's rss-advisory cache file.
//Place the css info at the end of this file with the css for the page where you're using it 
// (or external css file).
// Code based on 'warnscroll.php' by
//Jim McMurry - jmcmurry@mwt.net - jcweather.us October 2007
//
// PHP script modified by Ken True, webmaster@saratoga-weather.org
// 
// script available at http://saratoga-weather.org/scripts.php
//
// Version 1.00 - 07-Nov-2007 - Initial release (with thanks to Jim of jcweather.us )
// Version 1.01 - 04-Jan-2008 - added support for Carterlake/AJAX/PHP template set
// Version 1.02 - 17-Mar-2008 - modified cache error handling for more infomation
// Version 1.03 - 25-Mar-2008 - corrected HTML comment error codes
// Version 1.04 - 06-Apr-2008 - corrected HTML comment error code (MChallis)
//
$Version = "rss-top-warning.php - V1.04 06-Apr-2008";
//  
// you may copy/modify/use this script as you see fit,
// no warranty is expressed or implied.
//
// This script gets the current RSS Zone Watch/Warning/Advisory/Statement
// from www.weather.gov/alerts/ for the selected Zone and provides either
// a summary (titles only, with links) or details.  It returns nothing,
//  if there are no cited hazards in the Zone.
//
// output: creates XHTML 1.0-Strict HTML code (default)
//
//      zone=ssZnnn     -- select the Zone to use.  Pick the Zone from the
//                          RSS feed list at http://www.weather.gov/alerts/
//                         and use the RSS County/Zone for your area.
//      cache=refresh   -- reload the cache
//
// Usage:
//  This script is designed to work with the rss-advisory-test-c.php XML RSS
//  parser script to display the details of the advisory/warning
//  include this script in an existing page using:
//  no parms:    include("rss-top-warning.php"); 
//  parms:    include("http://your.website/rss-top-warning.php?&zone=CAZ513");
//
//
// settings:  
//  change $Zone default(below) to your stations county zone 
//    other settings are outlined below, and are optional
// 
// settings ----------------------------------------------------------
$DefaultZone = 'CAZ513'; // <== change this to your zone
$hurlURL = "rss-advisory.php?zone=ZZZZZ"; // <=== change this default to webpage
//                                         to open for details
//                                         the ZZZZZ will be replaced by the zone used
//
//  on that page, you can have the following PHP
//
//  if ( ! isset($_REQUEST['zone']) ) {
//        $_REQUEST['zone']="CAZ513";  // <=== Change this to your Zone
//	}
//  $Zone = $_REQUEST['zone']; 
//
//  include("http://your.website/rss-advisory.php?zone=$Zone&inc=Y");
// 
// --- you should not need to change the settings below ---  
// cacheName is name of file used to store cached current conditions
// 
  $cacheName = "rss-advisory.txt";  // used to store the file so we 
//                                        don't have to fetch it each time
// note: the real cache name will be the above name with the Zone included
//   ie:  rss-advisory.txt => rss-advisory-CAZ513.txt
//
  $refetchSeconds = 600;     // refetch every nnnn seconds (600=10 minutes)
//
// end of settings -------------------------------------------------
// overrides from Settings.php if available
global $SITE;
if (isset($SITE['noaazone'])) 	{$DefaultZone = $SITE['noaazone'];}
if (isset($SITE['hurlURL'])) 	{$hurlURL = $SITE['hurlURL'];}
if (isset($SITE['timeFormat'])) {$timeFormat = $SITE['timeFormat'];}
if (isset($SITE['tz'])) 		{$ourTZ = $SITE['tz'];}
// end of overrides from Settings.php if available
if (isset($_REQUEST['sce']) and strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}

//  get request parameters 
if ( ! isset($_REQUEST['zone']) ) {
        $_REQUEST['zone']="$DefaultZone";  
	}
$Zone = $_REQUEST['zone'];

if (isset($useZone)) {
   $Zone = $useZone;
}
 
if (isset($_REQUEST['cache']) and strtolower($_REQUEST['cache']) == 'refresh') {
  $refetchSeconds = 1;  // set short period for refresh of cache
}
// fix up zone if need be.... only alpha-numeric and uppercase needed
$Zone = strtoupper(preg_replace('/[^A-Za-z0-9]/i','',$Zone));

$advisoryurl="http://www.weather.gov/alerts/wwarssget.php?zone=$Zone"; //Zone will be the same as in rss-advisory.php
if ($Zone <> $DefaultZone and ! preg_match('|\?zone=|i',$hurlURL) ) {
  $hurlURL .= "?zone=ZZZZZ";
}
$hurlURL = preg_replace('|ZZZZZ|',$Zone,$hurlURL);

$myadvisorypage=$hurlURL; //The url you want to use to go to your advisory page

$cacheName = preg_replace('|\.txt$|i',"-$Zone.txt",$cacheName);
   
//Begins the Script 
//import NOAA Advisory info
//Target data ends up in $warnscroll
$html="";
$Status = '';

if (file_exists($cacheName) and filemtime($cacheName) + $refetchSeconds > time()) {  //600=10 min
	$age = time() - filectime($cacheName);
	$nextFetch = $refetchSeconds - $age;
    $Status .= "<!-- using cached version from $cacheName - age=$age secs. Next fetch in $nextFetch secs. -->\n";
	$fp = fopen($cacheName,"r") or die("Unable to open cache $cacheName for RSS data.");
	$html = fread($fp,filesize($cacheName));
	fclose($fp);
	if (strlen($html) < 20) {
	  $Status .= "<!-- Warning: cache file size=" . strlen($html) . " is too small.. XML data not found. -->\n";
	}
} else {
    $Status .= "<!-- getting cache from $advisoryurl -->\n";
	$xml = fetchUrlWithoutHangingTW($advisoryurl,$cacheName);
	list($junk,$html) = explode("\r\n\r\n",$xml,2);
	if (strlen($html) > 20) {
	  $fp = fopen($cacheName, "w");
      if ($fp) {
        $write = fputs($fp, $html);
        fclose($fp);
		$Status .= "<!-- cache saved to $cacheName -->\n";
      } else {
	    $Status .= "<!-- unable to write $cacheName -->\n";
      }
	} else {
	   $Status .= "<!-- HTML fetch length = " . strlen($html) . " ; Cache not saved. -->\n";
	   $Status .= "<!-- headers " . $junk . " -->\n";
	}
}

//Get the advisory headers from the XML and put them in an array
preg_match_all('/<title[^>]*>(.*)<\/title>/Uis', $html, $headers);  
$warnheaders = $headers[1];
//If there is more than one advisory, we need to set its priority
//If there aren't any advsiories... we stop here... displaying nothing
$i = 0;
$flag = 0;
$warnscroll = "";

if (count($warnheaders) >= 1) {

//First, around here tornados are the biggest danger. A warning is critical information.
//Display this one first no matter what!
    $i = 0;
	while ($i < count($warnheaders)):
		$WLink = $i-1;
		if (preg_match("/Tornado Warning/i", $warnheaders[$i]) and !preg_match("/National/i", $warnheaders[$i])){  
				$warnscroll = '<div class="tornadowarningBox"><a href="' . $myadvisorypage . "#WL$WLink" . '" style="color: #FFFFFF;"><b><span style="text-transform: uppercase;">' . $warnheaders[$i] .'</span></b> In Effect  ... [Click here for more]</a></div>';
			$flag = 1;
			break;
		}
		$i++;
	endwhile;

//Next if there are none of the above found. Display the first warning message.
	if ($flag == 0) {
		$i = 0;
		while ($i < count($warnheaders)):
		    $WLink = $i-1;
			if (preg_match("/Warning/i", $warnheaders[$i]) and !preg_match("/National/i", $warnheaders[$i]) and !preg_match("/There are no/i", $warnheaders[$i]) ) {  
				$warnscroll = '<div class="warningBox"><a href="' . $myadvisorypage . "#WL$WLink" . '" style="color: #FFFFFF;">' . $warnheaders[$i] .' In Effect ... [Click here for more]</a></div>';
				$flag = 1;
				break;
			}
			$i++;
		endwhile;
	}

//Next if there are none of the above found. Display the first watch message.
if ($flag == 0) {
		$i = 0;
		while ($i < count($warnheaders)):
		    $WLink = $i-1;
			if (preg_match("/Watch/i", $warnheaders[$i]) and !preg_match("/National/i", $warnheaders[$i]) and !preg_match("/There are no/i", $warnheaders[$i])) {  
				$warnheaders[0] = $warnheaders[$i];
				$warnscroll = '<div class="watchBox"><a href="' . $myadvisorypage . "#WL$WLink" . '" style="color: #000000;">' . $warnheaders[0] .' In Effect ... [Click here for more]</a></div>';
				$flag = 1;
				break;
			}
			$i++;
		endwhile;
	}

//Next if there are none of the above found. Display the first advisory message.
	if ($flag == 0) {
		$i = 0;
		while ($i < count($warnheaders)):
		    $WLink = $i-1;
			if (preg_match("/Advisory/i", $warnheaders[$i]) and !preg_match("/National/i", $warnheaders[$i])) {  
				$warnscroll = '<div class="advisoryBox"><a href="' . $myadvisorypage . "#WL$WLink" . '" style="color: #000000;">' . $warnheaders[$i] .' In Effect ... [Click here for more]</a></div>';
				$flag = 1;
				break;
			}
			$i++;
		endwhile;
	}

//Next if there are none of the above found. Display the first statement message.
	if ($flag == 0) {
		$i = 0;
		while ($i < count($warnheaders)):
		    $WLink = $i-1;
			if (preg_match("/Statement/i", $warnheaders[$i]) and !preg_match("/National/i", $warnheaders[$i])) {  
				$warnscroll = '<div class="advisoryBox"><a href="' . $myadvisorypage . "#WL$WLink" . '" style="color: #000000;">' . $warnheaders[$i] .' In Effect ... [Click here for more]</a></div>';
				$flag = 1;
				break;
			}
			$i++;
		endwhile;
	}
//Next if there are none of the above found. Display the first Short Term Forecast message
	if ($flag == 0) {
		$i = 0;
		while ($i < count($warnheaders)):
		    $WLink = $i-1;
			if (preg_match("/Forecast/i", $warnheaders[$i]) and !preg_match("/National/i", $warnheaders[$i])) {  
				$warnscroll = '<div class="advisoryBox"><a href="' . $myadvisorypage . "#WL$WLink" . '" style="color: #000000;">' . $warnheaders[$i] .' Issued ... [Click here for more]</a></div>';
				$flag = 1;
				break;
			}
			$i++;
		endwhile;
	}

}
echo "<!-- $Version -->\n";
echo $Status;
echo $warnscroll . "\n";
// End of script

function fetchUrlWithoutHangingTW($url,$cacheurl)
   {
   // Set maximum number of seconds (can have floating-point) to wait for feed before displaying page without feed
   $numberOfSeconds=4;    
   // Suppress error reporting so Web site visitors are unaware if the feed fails
   error_reporting(0);
   // Extract resource path and domain from URL ready for fsockopen

   $url = str_replace("http://","",$url);
   $urlComponents = explode("/",$url);
   $domain = $urlComponents[0];
   $resourcePath = str_replace($domain,"",$url);
   // Establish a connection
   $socketConnection = fsockopen($domain, 80, $errno, $errstr, $numberOfSeconds);
   if (!$socketConnection)
       {
       $html = implode('', file($cacheurl));
       return($html);
       }    // end if
   else    {
       $xml = '';
   		fputs($socketConnection, "GET $resourcePath HTTP/1.0\r\nHost: $domain\r\nUser-agent: $UA\r\nConnection: close\r\n\r\n");
       // Loop until end of file
       while (!feof($socketConnection))
           {
           $xml .= fgets($socketConnection, 4096);
           }    // end while
       fclose ($socketConnection);
       }    // end else
   return($xml);
   }    // end function
//
// The following to be placed in your css file.  Change colors etc to suit. 
/*  ---------- start if CSS (one line below this)-----------------
.advisoryBox {
  color: black;
  font-size: 12px;
  text-align: center;
  background-color: #FFFF85;       
  margin: 0 0 0 0;
  padding: .5em 0em .5em 0em;
  border: 0px dashed rgb(34,70,79);
}
.watchBox {
  color: black;
  font-size: 12px;
  text-align: center;
  background-color: #B3F7FF;      
  margin: 0 0 0 0;
  padding: .5em 0em .5em 0em;
  border: 0px dashed rgb(34,70,79);
}
.warningBox {
  color: white;
  font-size: 13px;
  text-align: center;
  background-color: #E28080;         
  margin: 0 0 0 0;
  padding: .5em 0em .5em 0em;
  border: 0px dashed rgb(255,255,255);
}
.tornadowarningBox {
  color: white;
  font-size: 13px;
  text-align: center;
  background-color: #CC0000;
  margin: 0 0 0 0;
  padding: .5em 0em .5em 0em;
  border: 1px dashed rgb(255,255,255);
}
-----end of CSS (one line above this)----------------------------- */  
?>


