<?php
############################################################################
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-World template set)
############################################################################
#
#   Project:    Sample Included Website Design
#   Module:     sample.php
#   Purpose:    Sample Page
#   Authors:    Kevin W. Reed <kreed@tnet.com>
#               TNET Services, Inc.
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
############################################################################
#	This document uses Tab 4 Settings
############################################################################
require_once("Settings.php");
require_once("common.php");
############################################################################
$TITLE= $SITE['organ'] . " - Astronomy";
$showGizmo = true;  // set to false to exclude the gizmo
include("top.php");
############################################################################
?>
</head>
<body>
<?php
############################################################################
include("header.php");
############################################################################
include("menubar.php");
############################################################################
# NOTE: you don't have to change these defaults.. use Settings.php to set your values.
$timeFormat = 'd-M-Y g:ia';  // 31-Mar-2006 6:35pm
//$timeFormat = 'd-M-Y H:i';   // 31-Mar-2006 18:35
$timeOnlyFormat = 'g:ia';    // h:mm[am|pm];
//$timeOnlyFormat = 'H:i';     // hh:mm
$dateOnlyFormat = 'd-M-Y';   // d-Mon-YYYY
$WDdateMDY = true;     // true=dates by WD are 'month/day/year'
//                     // false=dates by WD are 'day/month/year'
$ourTZ = "PST8PDT";  //NOTE: this *MUST* be set correctly to
// translate UTC times to your LOCAL time for the displays.
if (isset($SITE['timeFormat'])) {$timeFormat = $SITE['timeFormat'];}
if (isset($SITE['timeOnlyFormat'])) {$timeOnlyFormat = $SITE['timeOnlyFormat'];}
if (isset($SITE['dateOnlyFormat'])) {$dateOnlyFormat = $SITE['dateOnlyFormat'];}
if (isset($SITE['WDdateMDY']))  {$WDdateMDY = $SITE['WDdateMDY'];}
if (isset($SITE['tz'])) 		{$ourTZ = $SITE['tz'];}
$DebugMode = false;
if (isset($_REQUEST['debug'])) {$DebugMode = strtolower($_REQUEST['debug']) == 'y'; }
?>
<div id="main-copy-dark">
  
<h3>Astronomy Information</h3> 

<br />

<div align="center">
  <table width="99%" cellpadding="0" border="0" cellspacing="0">
  <tr>
    <td width="50%" align="center"><h3>Sun</h3></td>
    <td width="50%" align="center"><h3>Moon</h3></td>
  </tr>
  <tr>
    <td width="50%" align="center">
    <img border="0" src="<?php print $SITE['imagesDir']; ?>sunicon.jpg" width="104" height="72" alt="Sun"/></td>
    <td width="50%" align="center">
    <img border="0" src="moonicon.gif" width="104" height="72" 
	  alt="<?php print $moonage; ?>" title="<?php print $moonage; ?>"/></td>
  </tr>
  <tr>
      <td width="50%" align="center">Sunrise: <?php print adjustWDtime($sunrise); ?><br />
      Sunset: <?php print adjustWDtime($sunset); ?><br />
      Daylight: <?php print $hoursofpossibledaylight; ?></td>
      <td width="50%" align="center">
	  Moonrise: <?php print adjustWDtime($moonrise); 
	  if(isset($moonrisedate)) { print ' (' . adjustWDdate($moonrisedate) . ')';} ?><br />
	  Moonset: <?php print adjustWDtime($moonset); 
	  if(isset($moonsetdate)) { print ' (' . adjustWDdate($moonsetdate) . ')';} ?><br />
	  <?php echo $moonphasename; ?><br/>
	  <?php print $moonphase; ?> illuminated</td>
  </tr>
</table>
</div>

<br /><br />

<div align="center">
  <table width="99%" cellpadding="0" border="0" cellspacing="0">
    <tr>
      <td width="25%" align="center">First Quarter Moon</td>
      <td width="25%" align="center">Full Moon</td>
      <td width="25%" align="center">Last Quarter Moon</td>
      <td width="25%" align="center">New Moon</td>
    </tr>
    <tr>
      <td align="center">
      <img src="<?php print $SITE['imagesDir']; ?>moon-firstquar.gif" width="100" height="100" 
	  alt="First Quarter Moon"
	  title="First Quarter Moon"/></td>
      <td align="center">
      <img src="<?php print $SITE['imagesDir']; ?>moon-fullmoon.gif" width="100" height="100" 
	  alt="Full Moon"
	  title="Full Moon"/></td>
      <td align="center">
      <img src="<?php print $SITE['imagesDir']; ?>moon-lastquar.gif" width="100" height="100" 
	  alt="Last Quarter Moon"
	  title="Last Quarter Moon"/></td>
      <td align="center">
      <img src="<?php print $SITE['imagesDir']; ?>moon-newmoon.gif" width="100" height="100" 
	  alt="New Moon"
	  title="New Moon"/></td>
    </tr>
    <tr>
      <td width="25%" align="center">
	  <?php echo get_localdate($firstquarter); ?><br/><small><?php echo $firstquarter; ?></small></td>
      <td width="25%" align="center">
	  <?php echo get_localdate($fullmoon); ?><br/><small><?php echo $fullmoon; ?></small></td>
      <td width="25%" align="center">
	  <?php echo get_localdate($lastquarter); ?><br/><small><?php echo $lastquarter; ?></small></td>
      <td width="25%" align="center">
	  <?php echo get_localdate($nextnewmoon); ?><br/><small><?php echo $nextnewmoon; ?></small></td>
    </tr>
  </table>
</div>
<br/><br/>
<div align="center">
<table width="99%" cellpadding="0" border="0" cellspacing="0">
    <tr>
      <td align="center">Vernal Equinox<br/><small>Start of Spring</small></td>
      <td align="center">Summer Solstice<br/><small>Start of Summer</small></td>
      <td align="center">Autumn Equinox<br/><small>Start of Fall</small></td>
      <td align="center">Winter Solstice<br/><small>Start of Winter</small></td>
    </tr>
    <tr>
      <td align="center">
      <img src="<?php print $SITE['imagesDir']; ?>earth-spring.jpg" width="125" height="125"
	   alt="Start of Spring"
	   title="Start of Spring"/></td>
      <td align="center">
<?php if($SITE['latitude'] >=0) { // Use Northern Summer ?>
      <img src="<?php print $SITE['imagesDir']; ?>earth-summer.jpg" width="125" height="125"
	<?php } else { // use Southern Summer image ?>
      <img src="<?php print $SITE['imagesDir']; ?>earth-winter.jpg" width="125" height="125" 
<?php } // end Northern Summer test ?>	
	   alt="First day of Summer"
	   title="First day of Summer"/></td>
      <td align="center">
      <img src="<?php print $SITE['imagesDir']; ?>earth-fall.jpg" width="125" height="125" 
	  alt="First day of Fall"
	  title="First day of Fall"/></td>
      <td align="center">
<?php if($SITE['latitude'] >=0) { // Use Northern Winter ?>
      <img src="<?php print $SITE['imagesDir']; ?>earth-winter.jpg" width="125" height="125" 
	<?php } else { // use Southern Winter image ?>
      <img src="<?php print $SITE['imagesDir']; ?>earth-summer.jpg" width="125" height="125"
<?php } // end Northern Winter test ?>	
	  alt="First day of Winter"
	  title="First day of Winter"/></td>
    </tr>
    <tr>
<?php if ($SITE['latitude'] >= 0) { // Use Northern Hemisphere dates with images?>
      <td align="center">
	  <?php echo get_localdate($marchequinox); ?><br/><small><?php echo $marchequinox; ?></small></td>
      <td align="center">
	  <?php echo get_localdate($junesolstice); ?><br/><small><?php echo $junesolstice; ?></small></td>
      <td align="center">
	  <?php echo get_localdate($sepequinox); ?><br/><small><?php echo $sepequinox; ?></small></td>
      <td align="center">
	  <?php echo get_localdate($decsolstice); ?><br/><small><?php echo $decsolstice; ?></small></td>
<?php } else { // Use Southern Hemisphere dates with images ?>
      <td align="center">
     <?php echo get_localdate($sepequinox); ?><br/><small><?php echo $sepequinox; ?></small></td>
      <td align="center">
     <?php echo get_localdate($decsolstice); ?><br/><small><?php echo $decsolstice; ?></small></td>
      <td align="center">
     <?php echo get_localdate($marchequinox); ?><br/><small><?php echo $marchequinox; ?></small></td>
      <td align="center">
     <?php echo get_localdate($junesolstice); ?><br/><small><?php echo $junesolstice; ?></small></td>
<?php } // end test for Hemisphere ?>
    </tr>
  </table>

<p>&nbsp;
<?php if(file_exists("moondetail1.gif")) { ?>
<img src="moondetail1.gif" alt="Moon Details from Weather-Display" style="border: white 1px solid" /><br/><br/>
<?php }
      if(file_exists("moondetail2.gif")) { ?>
<img src="moondetail2.gif" alt="Additional Moon facts from Weather-Display"  style="border: white 1px solid"/>
<?php } ?>
</p>


</div>
</div><!-- end main-copy -->
<?php
function get_localdate ( $indate) {
  global $SITE;
  $EnglishMonths = array(
   'January','February','March','April','May','June',
   'July','August','September','October','November','December');

// Change '02:33 UTC 4 September 2007' to
//        specified date by  
  $timeFormat = 'D, d-M-Y h:ia T';  // Fri, 31-Mar-2006 14:03 TZone
//  $timeFormat = 'h:ia T D, d-M-Y ';  // Fri, 31-Mar-2006 14:03 TZone
  if(isset($SITE['timeFormat'])) { $timeFormat = $SITE['timeFormat']; }
  
  $utcstr = substr($indate,10) . " " . substr($indate,0,9); // move formats

  if (isset($SITE['monthNames'])) {
    // convert TO English for strtotime()
    echo "<!-- before utcstr='$utcstr' -->\n";
	foreach ($EnglishMonths as $i => $monthEN) {
	   $utcstr = preg_replace('|'.$SITE['monthNames'][$i].'|i',$monthEN,$utcstr);
	}  
    echo "<!-- after utcstr='$utcstr' -->\n";
  }
  $utc = strtotime($utcstr);
  $lclstr = date($timeFormat,$utc);
  if (isset($SITE['monthNames'])) {
    // convert From English for return (will only work if long-format month names in $timeFormat)  
    echo "<!-- before lclstr='$lclstr' -->\n";
	foreach ($EnglishMonths as $i => $monthEN) {
	   $lclstr = preg_replace('|'.$monthEN.'|i',$SITE['monthNames'][$i],$lclstr);
	}  
    echo "<!-- after lclstr='$lclstr' -->\n";
  }
  return ($lclstr);
}

# locally used functions
//=========================================================================
// change the hh:mm AM/PM to h:mmam/pm format or format spec by $timeOnlyFormat
function adjustWDtime ( $WDtime ) {
  global $timeOnlyFormat,$DebugMode;
  if ($WDtime == "00:00: AM") { return ''; }
  $t = split(':',$WDtime);
  if (preg_match('/pm/i',$WDtime)) { $t[0] = $t[0] + 12; }
  if ($t[0] > 23) {$t[0] = 12; }
  if (preg_match('/^12.*am/i',$WDtime)) { $t[0] = 0; }
  $t2 = join(':',$t); // put time back to gether;
  $t2 = preg_replace('/[^\d\:]/is','',$t2); // strip out the am/pm if any
  $r = date($timeOnlyFormat , strtotime($t2));
  if ($DebugMode) {
    $r = "<!-- adjustWDtime WDtime='$WDtime' t2='$t2' -->" . $r;
    $r = '<span style="color: green;">' . $r . '</span>'; 
  }
  return ($r);
}
//=========================================================================
// adjust WD date to desired format
//
function adjustWDdate ($WDdate) {
  global $timeFormat,$timeOnlyFormat,$dateOnlyFormat,$WDdateMDY,$DebugMode;
  $d = split('/',$WDdate);
  if ($d[2] > 70 and $d[2] <= 99) {$d[2] += 1900;} // 2 digit dates 70-99 are 1970-1999
  if ($d[2] < 99) {$d[2] += 2000; } // 2 digit dates (left) are assumed 20xx dates.
  if ($WDdateMDY) {
    $new = sprintf('%04d-%02d-%02d',$d[2],$d[0],$d[1]); //  M/D/YYYY -> YYYY-MM-DD
  } else {
    $new = sprintf('%04d-%02d-%02d',$d[2],$d[1],$d[0]); // D/M/YYYY -> YYYY-MM-DD
  }
  
  $r = date($dateOnlyFormat,strtotime($new));
  if ($DebugMode) {
    $r = "<!-- adjustDate WDdate='$WDdate', WDdateUSA='$WDdateMDY' new='$new' -->" . $r;
    $r = '<span style="color: green;">' . $r . '</span>'; 
  }
  return ($r);
}

?>

<?php
############################################################################
include("footer.php");
############################################################################
# End of Page
############################################################################
?>