<?php
############################################################################
# A Project of TNET Services, Inc. and Saratoga-Weather.org (WD-USA template set)
############################################################################
#
#   Project:    Sample Included Website Design
#   Module:     sample.php
#   Purpose:    Sample Page
#   Authors:    Kevin W. Reed <kreed@tnet.com>
#               TNET Services, Inc.
#
# 	Copyright:	(c) 1992-2007 Copyright TNET Services, Inc.
############################################################################
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
############################################################################
#	This document uses Tab 4 Settings
############################################################################
require_once("Settings.php");
require_once("common.php");
############################################################################
$TITLE= $SITE['organ'] . " - Station Status";
$showGizmo = true;  // set to false to exclude the gizmo
include("top.php");
############################################################################
?>
</head>
<body>
<?php
############################################################################
include("header.php");
############################################################################
include("menubar.php");
############################################################################
?>

<div id="main-copy">
 
   <h1>Weather Station Status</h1>
  <?php
	include_once($SITE['WXtags']);
	global $SITE;
  ?>
   <p>This page shows the current status of the weather software used in the operation of this website.<br/><br/>
  Station system up for <b><?php print $windowsuptime; ?></b><br/>
  Station system free memory <b><?php print $freememory; ?></b><br/>
  Weather-Display V<?php echo $wdversion; ?>  last started <b><?php print $Startimedate; ?></b><br/></p>

  <table width="620" border="0" cellspacing="6" cellpadding="3" style="border-collapse:collapse">
    <tr>
      <th style="width: 40%" scope="col">Component</th>
      <th style="width: 15%" scope="col" align="center">Status</th>
      <th style="width: 10%" scope="col" align="right">Age<br />h:m:s</th>
      <th style="width: 35%" scope="col" align="right">Latest update time as of<br/> <?php print date($SITE['timeFormat'],time()); ?></th>
    </tr>
    <?php
	    do_check("Weather Display realtime",$SITE['clientrawfile'],15,'file');
		do_check("Weather Display data",$SITE['WXtags'],60*5+15,'file');
		// optional if you also have WeatherLink updating your website
		if(file_exists('NOAAMO.TXT')) {
	      do_check("WeatherLink",'NOAAMO.TXT',60*5+15,'file');
		}
        // 
		if (! isset($_SERVER['DOCUMENT_ROOT'] ) ) {
		   $path_trans = str_replace( '\\\\', '/', $_SERVER['PATH_TRANSLATED']);
		   $SELF = $_SERVER['PHP_SELF'];
		   $WEBROOT = substr($path_trans, 0, strlen($path_trans)-strlen($SELF) );
		}
		else {
		   $WEBROOT        = $_SERVER['DOCUMENT_ROOT'];
		}
		$path = realpath($WEBROOT . $SITE['GR3DIR'] . '/' ) . '/';
        $GR3file = $path . $SITE['GR3radar'] . "_" . $SITE['GR3type'] . "_0." . $SITE['GR3img'];
		print "<!-- GR3='$GR3file' -->\n";
		if(file_exists($GR3file)) {
			if(file_exists("radar-status.php")) { // add radar status check if available
	           echo "	<tr>\n";
               echo "	  <td colspan=\"4\">\n";
	           include_once("radar-status.php");
               echo "</td>\n";
              echo "	</tr>\n";
			}
		
           do_check("GRLevel3 Radar FTP",$GR3file,60*10+15,'file');
		}
		if($SITE['WXSIM'] and file_exists('plaintext.txt')) {
	       $doPrint = false;
		   include_once($SITE['WXSIMscript']);
		   print "<!-- wdate='$wdate' -->\n";
		   $lastWXSIM = strtotime($wdate);
		   // note: '6*60*60 + 2*60' is 6:02:00 hms
           do_check("WXSIM forecast",$lastWXSIM,6*60*60 + 2*60,'application');
		
        }
		
		if(file_exists('nexstorm.jpg')) {
           do_check("Nexstorm Lightning map",'nexstorm.jpg',10*60+15,'file');
		
        }
		if(file_exists('TRACReport.txt')) {
           do_check("Nexstorm TRACreport",'TRACReport.txt',10*60+15,'file');
		
        }
		if(file_exists('nexstorm_arc.dat')) {
           do_check("Nexstorm Data file",'nexstorm_arc.dat',10*60+15,'file');
		
        }
		
		// Add your own checks below here using the models above for guidance
		
	?>

  </table>
 


</div><!-- end main-copy -->
<?php
// Functions used on this page

function do_check($title, $fileOrAppTime,$maxFileSecs,$type='file') {
	if(preg_match('/file/i',$type)) {
	   $cur_status = do_check_file($fileOrAppTime,$maxFileSecs);
	} else {
	   $cur_status = do_check_applic($fileOrAppTime,$maxFileSecs);
	}
	 list($stat,$age,$data) = explode("\t",$cur_status);
echo "    <tr>
      <td>$title</td>
      <td align=\"center\">$stat</td>
      <td align=\"right\">$age</td>
      <td align=\"right\">$data</td>
    </tr>\n";
	
}
// check time on a file for last update
function do_check_file($chkfile,$maxFileSecs) {
  global $SITE;
  $timeFormat = $SITE['timeFormat']; 
  $now = time();
  if (file_exists($chkfile)) {
    $age = $now - filemtime($chkfile);
	$updateTime = date($timeFormat,filemtime($chkfile));
  } else {
    $age = 'unknown';
	$updateTime = 'file not found';
  }
  $status = '';
  $hms = sec2hms($age);
  print "<!-- $chkfile age = $age secs. $hms -->\n";
  $age = $hms;
  if (file_exists($chkfile) and (filemtime($chkfile) + $maxFileSecs > $now) ) {     // stale file
    $status = "<span style=\"color: green\"><b>Current</b></span>\t$age\t$updateTime ";

  } else {
    $status = "<span style=\"color: red\"><b>NOT Current</b></span>\t$age\t > " . sec2hms($maxFileSecs) ."<br/><b>$updateTime</b>";
  }
  
  return($status);


}
// check time on an application returned update time
function do_check_applic($applTime,$maxFileSecs) {
  global $SITE;
  $timeFormat = $SITE['timeFormat']; 
  $now = time();
    $age = $now - $applTime;
	$updateTime = date($timeFormat,$applTime);
  $status = '';
  $hms = sec2hms($age);
  
  print "<!-- $chkfile age = $age secs. $hms -->\n";
  $age=$hms;
  if ($applTime + $maxFileSecs > $now ) {     // stale file
    $status = "<span style=\"color: green\"><b>Current</b></span>\t$age\t$updateTime ";

  } else {
    $status = "<span style=\"color: red\"><b>NOT Current</b></span>\t$age\t > " . sec2hms($maxFileSecs) . " <br/><b>$updateTime</b>";
  }
  
  return($status);


}	
//
  function sec2hms ($sec, $padHours = false) 
  {

    // holds formatted string
    $hms = "";
    if (! is_numeric($sec)) { return($sec); }
    // there are 3600 seconds in an hour, so if we
    // divide total seconds by 3600 and throw away
    // the remainder, we've got the number of hours
    $hours = intval(intval($sec) / 3600); 

    // add to $hms, with a leading 0 if asked for
    $hms .= ($padHours) 
          ? str_pad($hours, 2, "0", STR_PAD_LEFT). ':'
          : $hours. ':';
     
    // dividing the total seconds by 60 will give us
    // the number of minutes, but we're interested in 
    // minutes past the hour: to get that, we need to 
    // divide by 60 again and keep the remainder
    $minutes = intval(($sec / 60) % 60); 

    // then add to $hms (with a leading 0 if needed)
    $hms .= str_pad($minutes, 2, "0", STR_PAD_LEFT). ':';

    // seconds are simple - just divide the total
    // seconds by 60 and keep the remainder
    $seconds = intval($sec % 60); 

    // add to $hms, again with a leading 0 if needed
    $hms .= str_pad($seconds, 2, "0", STR_PAD_LEFT);

    // done!
    return $hms;
    
  }
// end of functions
?>

<?php
############################################################################
include("footer.php");
############################################################################
# End of Page
############################################################################
?>